package ch.zhaw.projekt2.turnierverwaltung;

import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.scene.layout.Border;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.Pane;
import javafx.stage.Stage;

import java.io.IOException;
import java.net.URL;

public class Factory {
    private Tournament tournament;


    public Factory(){

    }

    public Tournament getTournament() {
        return tournament;
    }

    public void setTournament(Tournament tournament) {
        this.tournament = tournament;
    }

    public BorderPane loadMainWindow(){
        FXMLLoader loader = new FXMLLoader(getClass().getResource("mainWindow.fxml"));
        try {
            return loader.load();
        } catch (IOException e) {
            e.printStackTrace();
            //TODO handle and logging
        }
        return null;
    }

    public void loadTournamentList(BorderPane pane){
        setCenterOfBorderPane(pane, getClass().getResource("tournamentList/tournamentList.fxml"));
    }

    //Can be used to Open new Scene in same Stage.
    //This way possible to later give object to Controller
    public void loadParticipantFormular(BorderPane pane) {
        setCenterOfBorderPane(pane, getClass().getResource("participantAddFormular/participantFormular.fxml"));
    }

    private void setCenterOfBorderPane(BorderPane pane, URL location) {
        try {
            FXMLLoader loader = new FXMLLoader(location);
            pane.setCenter(loader.load());
            FXController controller = loader.getController();
            controller.setup(tournament, this);
        } catch (IOException e) {
            e.printStackTrace();
            //TODO handle and logging?
        }
    }




}
